"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/pagination.tsx
var pagination_exports = {};
__export(pagination_exports, {
  default: () => pagination_default
});
module.exports = __toCommonJS(pagination_exports);
var import_system4 = require("@nextui-org/system");
var import_react3 = require("react");
var import_use_pagination3 = require("@nextui-org/use-pagination");
var import_shared_icons = require("@nextui-org/shared-icons");
var import_shared_utils3 = require("@nextui-org/shared-utils");

// src/use-pagination.ts
var import_react = require("react");
var import_system = require("@nextui-org/system");
var import_use_pagination = require("@nextui-org/use-pagination");
var import_theme = require("@nextui-org/theme");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_shared_utils = require("@nextui-org/shared-utils");
var CURSOR_TRANSITION_TIMEOUT = 300;
function usePagination(originalProps) {
  const [props, variantProps] = (0, import_system.mapPropsVariants)(originalProps, import_theme.pagination.variantKeys);
  const {
    as,
    ref,
    classNames,
    dotsJump = 5,
    loop = false,
    showControls = false,
    total = 1,
    initialPage = 1,
    page,
    siblings,
    boundaries,
    onChange,
    className,
    renderItem,
    ...otherProps
  } = props;
  const Component = as || "ul";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const cursorRef = (0, import_react.useRef)(null);
  const itemsRef = (0, import_react.useRef)();
  const cursorTimer = (0, import_react.useRef)();
  function getItemsRefMap() {
    if (!itemsRef.current) {
      itemsRef.current = /* @__PURE__ */ new Map();
    }
    return itemsRef.current;
  }
  function getItemRef(node, value) {
    const map = getItemsRefMap();
    if (node) {
      map.set(value, node);
    } else {
      map.delete(value);
    }
  }
  function scrollTo(value) {
    const map = getItemsRefMap();
    const node = map.get(value);
    cursorTimer.current && clearTimeout(cursorTimer.current);
    if (node) {
      const { offsetLeft } = node;
      if (cursorRef.current) {
        cursorRef.current.setAttribute("data-moving", "true");
        cursorRef.current.style.transform = `translateX(${offsetLeft}px) scale(1.1)`;
      }
      cursorTimer.current = setTimeout(() => {
        if (cursorRef.current) {
          cursorRef.current.setAttribute("data-moving", "false");
          cursorRef.current.style.transform = `translateX(${offsetLeft}px) scale(1)`;
        }
        cursorTimer.current && clearTimeout(cursorTimer.current);
      }, CURSOR_TRANSITION_TIMEOUT);
    }
  }
  const { range, activePage, setPage, previous, next, first, last } = (0, import_use_pagination.usePagination)({
    page,
    total,
    initialPage,
    siblings,
    boundaries,
    showControls,
    onChange
  });
  (0, import_react.useEffect)(() => {
    if (activePage && !originalProps.disableAnimation) {
      scrollTo(activePage);
    }
  }, [
    activePage,
    originalProps.disableAnimation,
    originalProps.isCompact,
    originalProps.disableCursor
  ]);
  const slots = (0, import_react.useMemo)(
    () => (0, import_theme.pagination)({
      ...variantProps,
      disableCursor: originalProps.disableCursor || originalProps.disableAnimation
    }),
    [...Object.values(variantProps)]
  );
  const baseStyles = (0, import_shared_utils.clsx)(classNames == null ? void 0 : classNames.base, className);
  const onNext = () => {
    if (loop && activePage === total) {
      return first();
    }
    return next();
  };
  const onPrevious = () => {
    if (loop && activePage === 1) {
      return last();
    }
    return previous();
  };
  const getBaseProps = (props2 = {}) => {
    return {
      ...props2,
      ref: domRef,
      role: "navigation",
      "data-controls": (0, import_shared_utils.dataAttr)(showControls),
      "data-loop": (0, import_shared_utils.dataAttr)(loop),
      "data-dots-jump": dotsJump,
      "data-total": total,
      "data-active-page": activePage,
      className: slots.base({ class: baseStyles }),
      ...otherProps
    };
  };
  const getItemProps = (props2 = {}) => {
    return {
      ...props2,
      ref: (node) => getItemRef(node, props2.value),
      isActive: props2.value === activePage,
      className: slots.item({ class: classNames == null ? void 0 : classNames.item }),
      onPress: () => {
        if (props2.value !== activePage) {
          setPage(props2.value);
        }
      }
    };
  };
  const getCursorProps = (props2 = {}) => {
    return {
      ...props2,
      ref: cursorRef,
      activePage,
      className: slots.cursor({ class: classNames == null ? void 0 : classNames.cursor })
    };
  };
  return {
    Component,
    showControls,
    dotsJump,
    slots,
    classNames,
    loop,
    total,
    range,
    activePage,
    getItemRef,
    disableCursor: originalProps.disableCursor,
    disableAnimation: originalProps.disableAnimation,
    setPage,
    onPrevious,
    onNext,
    renderItem,
    getBaseProps,
    getItemProps,
    getCursorProps
  };
}

// src/pagination-item.tsx
var import_system2 = require("@nextui-org/system");

// src/use-pagination-item.ts
var import_react2 = require("react");
var import_use_pagination2 = require("@nextui-org/use-pagination");
var import_theme2 = require("@nextui-org/theme");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_utils = require("@react-aria/utils");
var import_dom_utils2 = require("@nextui-org/dom-utils");
var import_interactions = require("@react-aria/interactions");
var import_focus = require("@react-aria/focus");
var getItemAriaLabel = (page) => {
  if (!page)
    return;
  switch (page) {
    case import_use_pagination2.PaginationItemType.DOTS:
      return "dots element";
    case import_use_pagination2.PaginationItemType.PREV:
      return "previous page button";
    case import_use_pagination2.PaginationItemType.NEXT:
      return "next page button";
    case "first":
      return "first page button";
    case "last":
      return "last page button";
    default:
      return `pagination item ${page}`;
  }
};
function usePaginationItem(props) {
  const {
    as,
    ref,
    value,
    children,
    isActive,
    isDisabled,
    onPress,
    onClick,
    getAriaLabel = getItemAriaLabel,
    className,
    ...otherProps
  } = props;
  const Component = as || "li";
  const domRef = (0, import_dom_utils2.useDOMRef)(ref);
  const ariaLabel = (0, import_react2.useMemo)(
    () => isActive ? `${getAriaLabel(value)} active` : getAriaLabel(value),
    [value, isActive]
  );
  const handlePress = (e) => {
    if (onClick) {
      (0, import_shared_utils2.warn)("onClick is deprecated, use onPress instead.", "PaginationItem");
    }
    onPress == null ? void 0 : onPress(e);
  };
  const { pressProps } = (0, import_interactions.usePress)({
    isDisabled,
    onPress: handlePress
  });
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus.useFocusRing)();
  const getItemProps = (props2 = {}) => {
    return {
      ref: domRef,
      role: "button",
      tabIndex: isDisabled ? -1 : 0,
      "aria-label": ariaLabel,
      "aria-current": (0, import_shared_utils2.dataAttr)(isActive),
      "aria-disabled": (0, import_shared_utils2.dataAttr)(isDisabled),
      "data-active": (0, import_shared_utils2.dataAttr)(isActive),
      "data-focus-visible": (0, import_shared_utils2.dataAttr)(isFocusVisible),
      "data-focused": (0, import_shared_utils2.dataAttr)(isFocused),
      className: (0, import_shared_utils2.clsx)(isFocusVisible && [...import_theme2.ringClasses], className),
      ...(0, import_utils.mergeProps)(props2, pressProps, focusProps, otherProps)
    };
  };
  return {
    Component,
    children,
    ariaLabel,
    isFocused,
    isFocusVisible,
    getItemProps
  };
}

// src/pagination-item.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var PaginationItem = (0, import_system2.forwardRef)((props, ref) => {
  const { Component, children, getItemProps } = usePaginationItem({ ref, ...props });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(Component, { ...getItemProps(), children });
});
PaginationItem.displayName = "NextUI.PaginationItem";
var pagination_item_default = PaginationItem;

// src/pagination-cursor.tsx
var import_system3 = require("@nextui-org/system");
var import_dom_utils3 = require("@nextui-org/dom-utils");
var import_jsx_runtime2 = require("react/jsx-runtime");
var PaginationCursor = (0, import_system3.forwardRef)((props, ref) => {
  const { as, activePage, ...otherProps } = props;
  const Component = as || "span";
  const domRef = (0, import_dom_utils3.useDOMRef)(ref);
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(Component, { ref: domRef, "aria-hidden": true, ...otherProps, children: activePage });
});
PaginationCursor.displayName = "NextUI.PaginationCursor";
var pagination_cursor_default = PaginationCursor;

// src/pagination.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var Pagination = (0, import_system4.forwardRef)((props, ref) => {
  const {
    Component,
    dotsJump,
    slots,
    classNames,
    total,
    range,
    loop,
    activePage,
    disableCursor,
    disableAnimation,
    renderItem: renderItemProp,
    onNext,
    onPrevious,
    setPage,
    getItemRef,
    getBaseProps,
    getItemProps,
    getCursorProps
  } = usePagination({ ref, ...props });
  const renderItem = (0, import_react3.useCallback)(
    (value, index) => {
      const isBefore = index < range.indexOf(activePage);
      const key = `${value}-${index}`;
      if (renderItemProp && typeof renderItemProp === "function") {
        return renderItemProp({
          value,
          index,
          activePage,
          isActive: value === activePage,
          isPrevious: value === activePage - 1,
          isNext: value === activePage + 1,
          isFirst: value === 1,
          isLast: value === total,
          onNext,
          onPrevious,
          setPage,
          ref: typeof value === "number" ? (node) => getItemRef(node, value) : void 0,
          className: slots.item({ class: classNames == null ? void 0 : classNames.item })
        });
      }
      if (value === import_use_pagination3.PaginationItemType.PREV) {
        return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          pagination_item_default,
          {
            className: slots.prev({
              class: (0, import_shared_utils3.clsx)(
                classNames == null ? void 0 : classNames.prev,
                !loop && activePage === 1 && "opacity-50 pointer-events-none"
              )
            }),
            value,
            onPress: onPrevious,
            children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_shared_icons.ChevronIcon, {})
          },
          key
        );
      }
      if (value === import_use_pagination3.PaginationItemType.NEXT) {
        return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
          pagination_item_default,
          {
            className: slots.next({
              class: (0, import_shared_utils3.clsx)(
                classNames == null ? void 0 : classNames.next,
                !loop && activePage === total && "opacity-50 pointer-events-none"
              )
            }),
            value,
            onPress: onNext,
            children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_shared_icons.ChevronIcon, { className: "rotate-180" })
          },
          key
        );
      }
      if (value === import_use_pagination3.PaginationItemType.DOTS) {
        return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(
          pagination_item_default,
          {
            className: slots.item({
              class: (0, import_shared_utils3.clsx)(classNames == null ? void 0 : classNames.item, "group")
            }),
            value,
            onPress: () => isBefore ? setPage(activePage - dotsJump >= 1 ? activePage - dotsJump : 1) : setPage(activePage + dotsJump <= total ? activePage + dotsJump : total),
            children: [
              /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_shared_icons.EllipsisIcon, { className: "group-hover:hidden" }),
              isBefore ? /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_shared_icons.ForwardIcon, { className: "hidden group-hover:block rotate-180" }) : /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_shared_icons.ForwardIcon, { className: "hidden group-hover:block" })
            ]
          },
          key
        );
      }
      return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(pagination_item_default, { ...getItemProps({ value }), children: value }, `${value}-${index}`);
    },
    [activePage, dotsJump, getItemProps, loop, range, renderItemProp, slots, classNames, total]
  );
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(Component, { ...getBaseProps(), children: [
    !disableCursor && !disableAnimation && /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(pagination_cursor_default, { ...getCursorProps() }),
    range.map(renderItem)
  ] });
});
Pagination.displayName = "NextUI.Pagination";
var pagination_default = Pagination;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
