"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-pagination-item.ts
var use_pagination_item_exports = {};
__export(use_pagination_item_exports, {
  usePaginationItem: () => usePaginationItem
});
module.exports = __toCommonJS(use_pagination_item_exports);
var import_react = require("react");
var import_use_pagination = require("@nextui-org/use-pagination");
var import_theme = require("@nextui-org/theme");
var import_shared_utils = require("@nextui-org/shared-utils");
var import_utils = require("@react-aria/utils");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_interactions = require("@react-aria/interactions");
var import_focus = require("@react-aria/focus");
var getItemAriaLabel = (page) => {
  if (!page)
    return;
  switch (page) {
    case import_use_pagination.PaginationItemType.DOTS:
      return "dots element";
    case import_use_pagination.PaginationItemType.PREV:
      return "previous page button";
    case import_use_pagination.PaginationItemType.NEXT:
      return "next page button";
    case "first":
      return "first page button";
    case "last":
      return "last page button";
    default:
      return `pagination item ${page}`;
  }
};
function usePaginationItem(props) {
  const {
    as,
    ref,
    value,
    children,
    isActive,
    isDisabled,
    onPress,
    onClick,
    getAriaLabel = getItemAriaLabel,
    className,
    ...otherProps
  } = props;
  const Component = as || "li";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const ariaLabel = (0, import_react.useMemo)(
    () => isActive ? `${getAriaLabel(value)} active` : getAriaLabel(value),
    [value, isActive]
  );
  const handlePress = (e) => {
    if (onClick) {
      (0, import_shared_utils.warn)("onClick is deprecated, use onPress instead.", "PaginationItem");
    }
    onPress == null ? void 0 : onPress(e);
  };
  const { pressProps } = (0, import_interactions.usePress)({
    isDisabled,
    onPress: handlePress
  });
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus.useFocusRing)();
  const getItemProps = (props2 = {}) => {
    return {
      ref: domRef,
      role: "button",
      tabIndex: isDisabled ? -1 : 0,
      "aria-label": ariaLabel,
      "aria-current": (0, import_shared_utils.dataAttr)(isActive),
      "aria-disabled": (0, import_shared_utils.dataAttr)(isDisabled),
      "data-active": (0, import_shared_utils.dataAttr)(isActive),
      "data-focus-visible": (0, import_shared_utils.dataAttr)(isFocusVisible),
      "data-focused": (0, import_shared_utils.dataAttr)(isFocused),
      className: (0, import_shared_utils.clsx)(isFocusVisible && [...import_theme.ringClasses], className),
      ...(0, import_utils.mergeProps)(props2, pressProps, focusProps, otherProps)
    };
  };
  return {
    Component,
    children,
    ariaLabel,
    isFocused,
    isFocusVisible,
    getItemProps
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  usePaginationItem
});
